diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/wifi/model/wifi-spectrum-value-helper.cc ns-3.43/src/wifi/model/wifi-spectrum-value-helper.cc
--- ns-3.42/src/wifi/model/wifi-spectrum-value-helper.cc	2024-05-29 15:29:47.212073800 -0700
+++ ns-3.43/src/wifi/model/wifi-spectrum-value-helper.cc	2024-10-09 16:41:10.132656800 -0700
@@ -3,18 +3,7 @@
  * Copyright (c) 2010 TELEMATICS LAB, DEE - Politecnico di Bari
  * Copyright (c) 2017 Orange Labs
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Authors: Nicola Baldo <nbaldo@cttc.es>
  *          Giuseppe Piro  <g.piro@poliba.it>
@@ -23,14 +12,36 @@
 
 #include "wifi-spectrum-value-helper.h"
 
+#include "wifi-utils.h"
+
 #include "ns3/assert.h"
 #include "ns3/fatal-error.h"
 #include "ns3/log.h"
 
+#include <algorithm>
 #include <cmath>
+#include <iterator>
 #include <map>
+#include <numeric>
+#include <optional>
 #include <sstream>
 
+namespace
+{
+
+/**
+ * Lambda to print a vector of frequencies.
+ */
+auto printFrequencies = [](const std::vector<ns3::MHz_u>& v) {
+    std::stringstream ss;
+    for (const auto& centerFrequency : v)
+    {
+        ss << centerFrequency << " ";
+    }
+    return ss.str();
+};
+} // namespace
+
 namespace ns3
 {
 
@@ -39,56 +50,72 @@
 ///< Wifi Spectrum Model structure
 struct WifiSpectrumModelId
 {
-    uint32_t m_centerFrequency; ///< center frequency (in MHz)
-    uint16_t m_channelWidth;    ///< channel width (in MHz)
-    uint32_t m_carrierSpacing;  ///< carrier spacing (in Hz)
-    uint16_t m_guardBandwidth;  ///< guard band width (in MHz)
+    std::vector<MHz_u> centerFrequencies; ///< center frequency per segment
+    MHz_u channelWidth;                   ///< channel width
+    Hz_u carrierSpacing;                  ///< carrier spacing
+    MHz_u guardBandwidth;                 ///< guard band width
 };
 
 /**
  * Less than operator
- * \param a the first wifi spectrum to compare
- * \param b the second wifi spectrum to compare
- * \returns true if the first spectrum is less than the second spectrum
+ * \param lhs the left hand side wifi spectrum to compare
+ * \param rhs the right hand side wifi spectrum to compare
+ * \returns true if the left hand side spectrum is less than the right hand side spectrum
  */
 bool
-operator<(const WifiSpectrumModelId& a, const WifiSpectrumModelId& b)
+operator<(const WifiSpectrumModelId& lhs, const WifiSpectrumModelId& rhs)
 {
-    return (
-        (a.m_centerFrequency < b.m_centerFrequency) ||
-        ((a.m_centerFrequency == b.m_centerFrequency) && (a.m_channelWidth < b.m_channelWidth)) ||
-        ((a.m_centerFrequency == b.m_centerFrequency) && (a.m_channelWidth == b.m_channelWidth) &&
-         (a.m_carrierSpacing < b.m_carrierSpacing)) // to cover coexistence of 11ax with legacy case
-        || ((a.m_centerFrequency == b.m_centerFrequency) &&
-            (a.m_channelWidth == b.m_channelWidth) && (a.m_carrierSpacing == b.m_carrierSpacing) &&
-            (a.m_guardBandwidth <
-             b.m_guardBandwidth))); // to cover 2.4 GHz case, where DSSS coexists with OFDM
+    return std::tie(lhs.centerFrequencies,
+                    lhs.channelWidth,
+                    lhs.carrierSpacing,
+                    lhs.guardBandwidth) < std::tie(rhs.centerFrequencies,
+                                                   rhs.channelWidth,
+                                                   rhs.carrierSpacing,
+                                                   rhs.guardBandwidth);
+    // TODO: replace with default spaceship operator, but it seems currently not working with all
+    // compilers
 }
 
 static std::map<WifiSpectrumModelId, Ptr<SpectrumModel>>
     g_wifiSpectrumModelMap; ///< static initializer for the class
 
 Ptr<SpectrumModel>
-WifiSpectrumValueHelper::GetSpectrumModel(uint32_t centerFrequency,
-                                          uint16_t channelWidth,
-                                          uint32_t carrierSpacing,
-                                          uint16_t guardBandwidth)
+WifiSpectrumValueHelper::GetSpectrumModel(const std::vector<MHz_u>& centerFrequencies,
+                                          MHz_u channelWidth,
+                                          Hz_u carrierSpacing,
+                                          MHz_u guardBandwidth)
 {
-    NS_LOG_FUNCTION(centerFrequency << channelWidth << carrierSpacing << guardBandwidth);
+    NS_LOG_FUNCTION(printFrequencies(centerFrequencies)
+                    << channelWidth << carrierSpacing << guardBandwidth);
+    NS_ASSERT_MSG(centerFrequencies.size() <= 2,
+                  "Spectrum model does not support more than 2 segments");
+    if (centerFrequencies.size() != 1)
+    {
+        NS_ASSERT_MSG(centerFrequencies.front() != centerFrequencies.back(),
+                      "Center frequency of each segment shall be different");
+    }
+    // assume all frequency segments have the same width, hence split the guard bandwidth
+    // accordingly over the segments
+    guardBandwidth /= centerFrequencies.size();
     Ptr<SpectrumModel> ret;
-    WifiSpectrumModelId key{centerFrequency, channelWidth, carrierSpacing, guardBandwidth};
-    auto it = g_wifiSpectrumModelMap.find(key);
-    if (it != g_wifiSpectrumModelMap.end())
+    WifiSpectrumModelId key{centerFrequencies, channelWidth, carrierSpacing, guardBandwidth};
+    if (const auto it = g_wifiSpectrumModelMap.find(key); it != g_wifiSpectrumModelMap.cend())
     {
         ret = it->second;
     }
     else
     {
         Bands bands;
-        double centerFrequencyHz = centerFrequency * 1e6;
-        double bandwidth = (channelWidth + (2.0 * guardBandwidth)) * 1e6;
+        const auto [minCenterFrequency, maxCenterFrequency] =
+            std::minmax_element(centerFrequencies.cbegin(), centerFrequencies.cend());
+        const auto separationWidth =
+            (minCenterFrequency == maxCenterFrequency)
+                ? 0
+                : (*maxCenterFrequency - *minCenterFrequency - (channelWidth / 2));
+        NS_ASSERT(separationWidth == 0 || centerFrequencies.size() == 2);
+        Hz_u bandwidth = (channelWidth + (2 * guardBandwidth) + separationWidth) * 1e6;
         // For OFDM, the center subcarrier is null (at center frequency)
-        auto numBands = static_cast<uint32_t>((bandwidth / carrierSpacing) + 0.5);
+        uint32_t numBands = std::ceil(bandwidth / carrierSpacing);
         NS_ASSERT(numBands > 0);
         if (numBands % 2 == 0)
         {
@@ -98,14 +125,20 @@
         }
         NS_ASSERT_MSG(numBands % 2 == 1, "Number of bands should be odd");
         NS_LOG_DEBUG("Num bands " << numBands << " band bandwidth " << carrierSpacing);
-        // lay down numBands/2 bands symmetrically around center frequency
-        // and place an additional band at center frequency
-        double startingFrequencyHz =
-            centerFrequencyHz - (numBands / 2 * carrierSpacing) - carrierSpacing / 2;
+
+        // The lowest frequency is obtained from the minimum center frequency among the segment(s).
+        // Then, we subtract half the channel width to retrieve the starting frequency of the
+        // operating channel. If the channel is made of 2 segments, since the channel width is the
+        // total width, only a quarter of the channel width has to be subtracted. Finally, we
+        // remove the guard band width to get the center frequency of the first band and half the
+        // carrier spacing to get the effective starting frequency of the first band.
+        const auto startingFrequencyHz = *minCenterFrequency * 1e6 -
+                                         ((channelWidth * 1e6) / (2 * centerFrequencies.size())) -
+                                         (guardBandwidth * 1e6) - (carrierSpacing / 2);
         for (size_t i = 0; i < numBands; i++)
         {
             BandInfo info;
-            double f = startingFrequencyHz + (i * carrierSpacing);
+            auto f = startingFrequencyHz + (i * carrierSpacing);
             info.fl = f;
             f += carrierSpacing / 2;
             info.fc = f;
@@ -124,58 +157,59 @@
 
 // Power allocated to 71 center subbands out of 135 total subbands in the band
 Ptr<SpectrumValue>
-WifiSpectrumValueHelper::CreateDsssTxPowerSpectralDensity(uint32_t centerFrequency,
-                                                          double txPowerW,
-                                                          uint16_t guardBandwidth)
-{
-    NS_LOG_FUNCTION(centerFrequency << txPowerW << +guardBandwidth);
-    uint16_t channelWidth = 22; // DSSS channels are 22 MHz wide
-    uint32_t carrierSpacing = 312500;
+WifiSpectrumValueHelper::CreateDsssTxPowerSpectralDensity(MHz_u centerFrequency,
+                                                          Watt_u txPower,
+                                                          MHz_u guardBandwidth)
+{
+    NS_LOG_FUNCTION(centerFrequency << txPower << +guardBandwidth);
+    MHz_u channelWidth = 22; // DSSS channels are 22 MHz wide
+    Hz_u carrierSpacing = 312500;
     Ptr<SpectrumValue> c = Create<SpectrumValue>(
-        GetSpectrumModel(centerFrequency, channelWidth, carrierSpacing, guardBandwidth));
+        GetSpectrumModel({centerFrequency}, channelWidth, carrierSpacing, guardBandwidth));
     auto vit = c->ValuesBegin();
     auto bit = c->ConstBandsBegin();
     auto nGuardBands = static_cast<uint32_t>(((2 * guardBandwidth * 1e6) / carrierSpacing) + 0.5);
     auto nAllocatedBands = static_cast<uint32_t>(((channelWidth * 1e6) / carrierSpacing) + 0.5);
     NS_ASSERT(c->GetSpectrumModel()->GetNumBands() == (nAllocatedBands + nGuardBands + 1));
     // Evenly spread power across 22 MHz
-    double txPowerPerBand = txPowerW / nAllocatedBands;
+    const auto txPowerPerBand = txPower / nAllocatedBands;
+    const auto psd = txPowerPerBand / (bit->fh - bit->fl);
     for (size_t i = 0; i < c->GetSpectrumModel()->GetNumBands(); i++, vit++, bit++)
     {
         if ((i >= (nGuardBands / 2)) && (i <= ((nGuardBands / 2) + nAllocatedBands - 1)))
         {
-            *vit = txPowerPerBand / (bit->fh - bit->fl);
+            *vit = psd;
         }
     }
     return c;
 }
 
 Ptr<SpectrumValue>
-WifiSpectrumValueHelper::CreateOfdmTxPowerSpectralDensity(uint32_t centerFrequency,
-                                                          uint16_t channelWidth,
-                                                          double txPowerW,
-                                                          uint16_t guardBandwidth,
-                                                          double minInnerBandDbr,
-                                                          double minOuterBandDbr,
-                                                          double lowestPointDbr)
-{
-    NS_LOG_FUNCTION(centerFrequency << channelWidth << txPowerW << guardBandwidth << minInnerBandDbr
-                                    << minOuterBandDbr << lowestPointDbr);
-    uint32_t carrierSpacing = 0;
+WifiSpectrumValueHelper::CreateOfdmTxPowerSpectralDensity(MHz_u centerFrequency,
+                                                          MHz_u channelWidth,
+                                                          Watt_u txPower,
+                                                          MHz_u guardBandwidth,
+                                                          dBr_u minInnerBand,
+                                                          dBr_u minOuterBand,
+                                                          dBr_u lowestPoint)
+{
+    NS_LOG_FUNCTION(centerFrequency << channelWidth << txPower << guardBandwidth << minInnerBand
+                                    << minOuterBand << lowestPoint);
+    Hz_u carrierSpacing = 0;
     uint32_t innerSlopeWidth = 0;
-    switch (channelWidth)
+    switch (static_cast<uint16_t>(channelWidth))
     {
     case 20:
-        carrierSpacing = 312500;
+        carrierSpacing = 312500;                                               // Hz
         innerSlopeWidth = static_cast<uint32_t>((2e6 / carrierSpacing) + 0.5); // [-11;-9] & [9;11]
         break;
     case 10:
-        carrierSpacing = 156250;
+        carrierSpacing = 156250; // Hz
         innerSlopeWidth =
             static_cast<uint32_t>((1e6 / carrierSpacing) + 0.5); // [-5.5;-4.5] & [4.5;5.5]
         break;
     case 5:
-        carrierSpacing = 78125;
+        carrierSpacing = 78125; // Hz
         innerSlopeWidth =
             static_cast<uint32_t>((5e5 / carrierSpacing) + 0.5); // [-2.75;-2.5] & [2.5;2.75]
         break;
@@ -184,8 +218,8 @@
         return nullptr;
     }
 
-    Ptr<SpectrumValue> c = Create<SpectrumValue>(
-        GetSpectrumModel(centerFrequency, channelWidth, carrierSpacing, guardBandwidth));
+    auto c = Create<SpectrumValue>(
+        GetSpectrumModel({centerFrequency}, channelWidth, carrierSpacing, guardBandwidth));
     auto nGuardBands = static_cast<uint32_t>(((2 * guardBandwidth * 1e6) / carrierSpacing) + 0.5);
     auto nAllocatedBands = static_cast<uint32_t>(((channelWidth * 1e6) / carrierSpacing) + 0.5);
     NS_ASSERT_MSG(c->GetSpectrumModel()->GetNumBands() == (nAllocatedBands + nGuardBands + 1),
@@ -194,8 +228,8 @@
     // skip guard band and 6 subbands, then place power in 26 subbands, then
     // skip the center subband, then place power in 26 subbands, then skip
     // the final 6 subbands and the guard band.
-    double txPowerPerBandW = txPowerW / 52;
-    NS_LOG_DEBUG("Power per band " << txPowerPerBandW << "W");
+    const auto txPowerPerBand = txPower / 52;
+    NS_LOG_DEBUG("Power per band " << txPowerPerBand << "W");
     uint32_t start1 = (nGuardBands / 2) + 6;
     uint32_t stop1 = start1 + 26 - 1;
     uint32_t start2 = stop1 + 2;
